* it.prg
* top level program 

*
* set stuff up
*
* talk is a special case
if set("talk") == "ON"
 set talk off
 m.gcOldTalk = "ON"
else
 m.gcOldTalk = "OFF"
endif
* save current environment
m.gcOldCent = set("century")
m.gcOldDele = set("deleted")
m.gcOldEsca = set("escape")
m.gcOldExac = set("exact")
m.gcOldExcl = set("exclusive")
m.gcOldMult = set("multilocks")
m.gcOldProc = set("procedure")
m.gcOldRepr = set("reprocess")
m.gcOldSafe = set("safety")
m.gcOldStat = set("status bar")
m.gcOldHelp = set("help",1)
m.gcOldReso = sys(2005)
m.gcOldOnEr = on("error")
* clean out everything
release all except g*
close all
clear menu
clear popup
clear window
clear
* set up outside resources
*\\\ set classlib to ("MYBASECLASSES")
*\\\ set help to ("MYHELP")
set procedure to ("MYPROC")
*\\\ set resource to ("MYRES")
* initialize various system attributes
* by reading in from outside the application 
* (either an INI file or the Windows Registry)
* (GetRegValue is a function in MYPROC)
m.glCanGoOn = .t.
m.gcNameSystem = GetRegValue("NameSystem")
m.gcVersion = GetRegValue("VersionSystem")
m.gcDefaultDataLocation = GetRegValue("DefautlDataLocation")
m.gnMinRAM = GetRegValue("MinRAM")
m.gnMinDiskSpace = GetRegValue("MinDiskSpace")
* make sure the default data set exists and is good
if !DataIsGood(m.gcDefaultDataLocation)
 m.glCanGoOn = .f.
endif
* check the hardware and OS
* (each of these functions is in MYPROC)
m.gnAvailRAM = GetRAM()
if m.gnAvailRAM < m.gnMinRAM
 m.glCanGoOn = .f.
endif
m.gnAvailDiskSpace = GetDiskSpace()
if m.gnAvailDiskSpace < m.gnMinDiskSpace
 m.glCanGoOn = .f.
endif
* initialize user login parms
m.gcNameUser = "ADMIN"
m.gcPassword = "ADMIN"
m.gcPermLevel = "00001"
m.glLoginWasGood = .t.
* get user login
do form LOGIN
if !m.glLoginWasGood
 m.glCanGoOn = .f.
endif
* set up On Error and On Escape values depending
* on if user has developer-level permissions
if m.gcPermLevel = "ADMIN"
 on error do DevError
 set escape on
else
 on error do UserError
 set escape off
 on escape * 
endif
* define environment
set century on
set clock status
set deleted on
set exact off
set exclusive off
set multilocks on
set reprocess to 5
set safety off
*
* set up event handler
*
* save old menu, run new one
if m.glCanGoOn
 push menu _MSYSMENU
 do IT.MPR
 read events
else
 * something bad happened so can't run app
 * (probably want to let the user know what)
endif
*
* clean up and close shop
*
* upon termination, restore menu 
pop menu _MSYSMENU  &&to master
set sysmenu to default
* return environment
set century &gcOldCent 
set deleted &gcOldDele 
set escape &gcOldEsca 
set exact &gcOldExac 
set exclusive &gcOldExcl 
set multilocks &gcOldMult 
set procedure to &gcOldProc
set reprocess to (m.gcOldRepr)
set safety &gcOldSafe 
set status bar &gcOldStat 
if file(m.gcOldHelp)
 m.cTemp = "'" + gcOldHelp + "'"
 set help to &cTemp
 rele m.cTemp
endif
if file(m.gcOldReso)
 set resource to &gcOldReso 
endif
on error &gcOldOnEr
* clean out everything else
close all
clear menu
clear popup
clea program
clear window
clear
set talk &gcOldTalk
* from within VFP or from runtime
if version(2) = 0
 wait window nowait "See ya later, alligator"
 clear memory
 quit
else
 @2,0 say "See ya later, alligator"
 clear memory
 return
endif

* <EOF>
